Add design document for Ganeti 2.5
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Use bash in order to be able to use pipefail
13 SHELL=/bin/bash
14
15 ACLOCAL_AMFLAGS = -I autotools
16 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
17 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
18 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
19 CHECK_MAN = $(top_srcdir)/autotools/check-man
20 CHECK_VERSION = $(top_srcdir)/autotools/check-version
21 CHECK_NEWS = $(top_srcdir)/autotools/check-news
22 DOCPP = $(top_srcdir)/autotools/docpp
23 REPLACE_VARS_SED = autotools/replace_vars.sed
24 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
25
26 # Note: these are automake-specific variables, and must be named after
27 # the directory + 'dir' suffix
28 clientdir = $(pkgpythondir)/client
29 hypervisordir = $(pkgpythondir)/hypervisor
30 httpdir = $(pkgpythondir)/http
31 masterddir = $(pkgpythondir)/masterd
32 confddir = $(pkgpythondir)/confd
33 rapidir = $(pkgpythondir)/rapi
34 serverdir = $(pkgpythondir)/server
35 watcherdir = $(pkgpythondir)/watcher
36 impexpddir = $(pkgpythondir)/impexpd
37 utilsdir = $(pkgpythondir)/utils
38 toolsdir = $(pkglibdir)/tools
39 iallocatorsdir = $(pkglibdir)/iallocators
40 pytoolsdir = $(pkgpythondir)/tools
41 docdir = $(datadir)/doc/$(PACKAGE)
42
43 # Delete output file if an error occurred while building it
44 .DELETE_ON_ERROR:
45
46 HTOOLS_DIRS = \
47         htools \
48         htools/Ganeti \
49         htools/Ganeti/HTools \
50         htools/Ganeti/HTools/Program
51
52 DIRS = \
53         autotools \
54         daemons \
55         devel \
56         doc \
57         doc/examples \
58         doc/examples/hooks \
59         doc/examples/gnt-debug \
60         $(HTOOLS_DIRS) \
61         lib \
62         lib/client \
63         lib/build \
64         lib/confd \
65         lib/http \
66         lib/hypervisor \
67         lib/impexpd \
68         lib/masterd \
69         lib/rapi \
70         lib/server \
71         lib/tools \
72         lib/utils \
73         lib/watcher \
74         man \
75         qa \
76         test \
77         test/data \
78         tools
79
80 BUILDTIME_DIR_AUTOCREATE = \
81         scripts \
82         $(APIDOC_DIR) \
83         $(APIDOC_PY_DIR) \
84         $(APIDOC_HS_DIR) \
85         $(APIDOC_HS_DIR)/Ganeti $(APIDOC_HS_DIR)/Ganeti/HTools \
86         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
87         $(COVERAGE_DIR) \
88         $(COVERAGE_PY_DIR) \
89         $(COVERAGE_HS_DIR) \
90         .hpc
91
92 BUILDTIME_DIRS = \
93         $(BUILDTIME_DIR_AUTOCREATE) \
94         doc/html
95
96 DIRCHECK_EXCLUDE = \
97         $(BUILDTIME_DIRS) \
98         ganeti-[0-9]*.[0-9]*.[0-9]* \
99         doc/html/_*
100
101 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
102
103 # some helper vars
104 COVERAGE_DIR = doc/coverage
105 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
106 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
107 APIDOC_DIR = doc/api
108 APIDOC_PY_DIR = $(APIDOC_DIR)/py
109 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
110
111 MAINTAINERCLEANFILES = \
112         $(docpng) \
113         $(maninput) \
114         doc/install-quick.rst \
115         doc/news.rst \
116         doc/upgrade.rst \
117         vcs-version
118
119 maintainer-clean-local:
120         rm -rf $(BUILDTIME_DIRS)
121
122 CLEANFILES = \
123         $(addsuffix /*.py[co],$(DIRS)) \
124         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
125         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
126         $(all_dirfiles) \
127         $(PYTHON_BOOTSTRAP) \
128         epydoc.conf \
129         autotools/replace_vars.sed \
130         daemons/daemon-util \
131         daemons/ganeti-cleaner \
132         devel/upload \
133         doc/examples/bash_completion \
134         doc/examples/ganeti.initd \
135         doc/examples/ganeti-kvm-poweroff.initd \
136         doc/examples/ganeti.cron \
137         doc/examples/gnt-config-backup \
138         doc/examples/hooks/ipsec \
139         $(man_MANS) \
140         $(manhtml) \
141         tools/kvm-ifup \
142         stamp-srclinks \
143         $(nodist_pkgpython_PYTHON) \
144         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
145         .hpc/*.mix htools/*.tix \
146         doc/hs-lint.html
147
148 # BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
149 # it'll cause the target to rebuild every time.
150 BUILT_SOURCES = \
151         ganeti \
152         stamp-srclinks \
153         lib/_autoconf.py \
154         lib/_vcsversion.py \
155         $(all_dirfiles) \
156         $(PYTHON_BOOTSTRAP)
157
158 nodist_pkgpython_PYTHON = \
159         lib/_autoconf.py \
160         lib/_vcsversion.py
161
162 noinst_PYTHON = \
163         lib/build/__init__.py \
164         lib/build/sphinx_ext.py
165
166 pkgpython_PYTHON = \
167         lib/__init__.py \
168         lib/asyncnotifier.py \
169         lib/backend.py \
170         lib/bdev.py \
171         lib/bootstrap.py \
172         lib/cli.py \
173         lib/cmdlib.py \
174         lib/compat.py \
175         lib/config.py \
176         lib/constants.py \
177         lib/daemon.py \
178         lib/errors.py \
179         lib/ht.py \
180         lib/jqueue.py \
181         lib/jstore.py \
182         lib/locking.py \
183         lib/luxi.py \
184         lib/mcpu.py \
185         lib/netutils.py \
186         lib/objects.py \
187         lib/opcodes.py \
188         lib/qlang.py \
189         lib/query.py \
190         lib/rpc.py \
191         lib/runtime.py \
192         lib/serializer.py \
193         lib/ssconf.py \
194         lib/ssh.py \
195         lib/storage.py \
196         lib/uidpool.py \
197         lib/workerpool.py
198
199 client_PYTHON = \
200         lib/client/__init__.py \
201         lib/client/gnt_backup.py \
202         lib/client/gnt_cluster.py \
203         lib/client/gnt_debug.py \
204         lib/client/gnt_group.py \
205         lib/client/gnt_instance.py \
206         lib/client/gnt_job.py \
207         lib/client/gnt_node.py \
208         lib/client/gnt_os.py
209
210 hypervisor_PYTHON = \
211         lib/hypervisor/__init__.py \
212         lib/hypervisor/hv_base.py \
213         lib/hypervisor/hv_chroot.py \
214         lib/hypervisor/hv_fake.py \
215         lib/hypervisor/hv_kvm.py \
216         lib/hypervisor/hv_lxc.py \
217         lib/hypervisor/hv_xen.py
218
219 rapi_PYTHON = \
220         lib/rapi/__init__.py \
221         lib/rapi/baserlib.py \
222         lib/rapi/client.py \
223         lib/rapi/client_utils.py \
224         lib/rapi/connector.py \
225         lib/rapi/rlib2.py
226
227 http_PYTHON = \
228         lib/http/__init__.py \
229         lib/http/auth.py \
230         lib/http/client.py \
231         lib/http/server.py
232
233 confd_PYTHON = \
234         lib/confd/__init__.py \
235         lib/confd/client.py \
236         lib/confd/querylib.py \
237         lib/confd/server.py
238
239 masterd_PYTHON = \
240         lib/masterd/__init__.py \
241         lib/masterd/instance.py
242
243 impexpd_PYTHON = \
244         lib/impexpd/__init__.py
245
246 watcher_PYTHON = \
247         lib/watcher/__init__.py \
248         lib/watcher/nodemaint.py \
249         lib/watcher/state.py
250
251 server_PYTHON = \
252         lib/server/__init__.py \
253         lib/server/confd.py \
254         lib/server/masterd.py \
255         lib/server/noded.py \
256         lib/server/rapi.py
257
258 pytools_PYTHON = \
259         lib/tools/__init__.py \
260         lib/tools/ensure_dirs.py
261
262 utils_PYTHON = \
263         lib/utils/__init__.py \
264         lib/utils/algo.py \
265         lib/utils/filelock.py \
266         lib/utils/hash.py \
267         lib/utils/io.py \
268         lib/utils/log.py \
269         lib/utils/mlock.py \
270         lib/utils/nodesetup.py \
271         lib/utils/process.py \
272         lib/utils/retry.py \
273         lib/utils/text.py \
274         lib/utils/wrapper.py \
275         lib/utils/x509.py
276
277 docrst = \
278         doc/admin.rst \
279         doc/design-2.0.rst \
280         doc/design-2.1.rst \
281         doc/design-2.2.rst \
282         doc/design-2.3.rst \
283         doc/design-htools-2.3.rst \
284         doc/design-2.4.rst \
285         doc/design-2.5.rst \
286         doc/design-draft.rst \
287         doc/design-oob.rst \
288         doc/design-cpu-pinning.rst \
289         doc/design-query2.rst \
290         doc/design-x509-ca.rst \
291         doc/design-http-server.rst \
292         doc/design-impexp2.rst \
293         doc/design-lu-generated-jobs.rst \
294         doc/design-multi-reloc.rst \
295         doc/design-network.rst \
296         doc/design-chained-jobs.rst \
297         doc/cluster-merge.rst \
298         doc/design-shared-storage.rst \
299         doc/devnotes.rst \
300         doc/glossary.rst \
301         doc/hooks.rst \
302         doc/iallocator.rst \
303         doc/index.rst \
304         doc/install-quick.rst \
305         doc/install.rst \
306         doc/locking.rst \
307         doc/move-instance.rst \
308         doc/news.rst \
309         doc/rapi.rst \
310         doc/security.rst \
311         doc/upgrade.rst \
312         doc/walkthrough.rst
313
314 HS_PROGS = htools/htools
315 HS_BIN_ROLES = hbal hscan hspace
316
317 HS_ALL_PROGS = $(HS_PROGS) htools/test
318 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
319 # we don't add -Werror by default
320 HFLAGS = -O -Wall -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
321 # extra flags that can be overriden on the command line
322 HEXTRA =
323 # exclude options for coverage reports
324 HPCEXCL = --exclude Main --exclude Ganeti.HTools.QC \
325         --exclude Ganeti.Constants \
326         --exclude Ganeti.HTools.Version
327
328 HS_LIB_SRCS = \
329         htools/Ganeti/HTools/CLI.hs \
330         htools/Ganeti/HTools/Cluster.hs \
331         htools/Ganeti/HTools/Compat.hs \
332         htools/Ganeti/HTools/Container.hs \
333         htools/Ganeti/HTools/ExtLoader.hs \
334         htools/Ganeti/HTools/Group.hs \
335         htools/Ganeti/HTools/IAlloc.hs \
336         htools/Ganeti/HTools/Instance.hs \
337         htools/Ganeti/HTools/Loader.hs \
338         htools/Ganeti/HTools/Luxi.hs \
339         htools/Ganeti/HTools/Node.hs \
340         htools/Ganeti/HTools/PeerMap.hs \
341         htools/Ganeti/HTools/QC.hs \
342         htools/Ganeti/HTools/Rapi.hs \
343         htools/Ganeti/HTools/Simu.hs \
344         htools/Ganeti/HTools/Text.hs \
345         htools/Ganeti/HTools/Types.hs \
346         htools/Ganeti/HTools/Utils.hs \
347         htools/Ganeti/HTools/Program/Hail.hs \
348         htools/Ganeti/HTools/Program/Hbal.hs \
349         htools/Ganeti/HTools/Program/Hscan.hs \
350         htools/Ganeti/HTools/Program/Hspace.hs \
351         htools/Ganeti/Jobs.hs \
352         htools/Ganeti/Luxi.hs \
353         htools/Ganeti/OpCodes.hs
354
355 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
356 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
357
358 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
359
360 # Note: we use here an order-only prerequisite, as the contents of
361 # _autoconf.py are not actually influencing the html build output: it
362 # has to exist in order for the sphinx module to be loaded
363 # successfully, but we certainly don't want the docs to be rebuilt if
364 # it changes
365 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
366         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/ht.py \
367         | lib/_autoconf.py lib/_vcsversion.py
368         @test -n "$(SPHINX)" || \
369             { echo 'sphinx-build' not found during configure; exit 1; }
370         @mkdir_p@ $(dir $@)
371         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
372             -d . \
373             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
374             -D release="$(PACKAGE_VERSION)" \
375             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
376         rm -f doc/html/.buildinfo doc/html/objects.inv
377         touch $@
378
379 doc/html: doc/html/index.html
380
381 doc/install-quick.rst: INSTALL
382 doc/news.rst: NEWS
383 doc/upgrade.rst: UPGRADE
384
385 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
386         set -e; \
387         { echo '.. This file is automatically updated at build time from $<.'; \
388           echo '.. Do not edit.'; \
389           echo; \
390           cat $<; \
391         } > $@
392
393 docdot = \
394         doc/arch-2.0.dot \
395         doc/design-2.1-lock-acquire.dot \
396         doc/design-2.1-lock-release.dot
397
398 docpng = $(patsubst %.dot,%.png,$(docdot))
399
400 # Things to build but not to install (add it to EXTRA_DIST if it should be
401 # distributed)
402 noinst_DATA = \
403         devel/upload \
404         doc/html \
405         doc/examples/bash_completion \
406         doc/examples/ganeti.cron \
407         doc/examples/ganeti.initd \
408         doc/examples/ganeti-kvm-poweroff.initd \
409         doc/examples/gnt-config-backup \
410         doc/examples/hooks/ipsec \
411         $(manhtml)
412
413 gnt_scripts = \
414         scripts/gnt-backup \
415         scripts/gnt-cluster \
416         scripts/gnt-debug \
417         scripts/gnt-group \
418         scripts/gnt-instance \
419         scripts/gnt-job \
420         scripts/gnt-node \
421         scripts/gnt-os
422
423 PYTHON_BOOTSTRAP_SBIN = \
424         daemons/ganeti-confd \
425         daemons/ganeti-masterd \
426         daemons/ganeti-noded \
427         daemons/ganeti-watcher \
428         daemons/ganeti-rapi \
429         scripts/gnt-backup \
430         scripts/gnt-cluster \
431         scripts/gnt-debug \
432         scripts/gnt-group \
433         scripts/gnt-instance \
434         scripts/gnt-job \
435         scripts/gnt-node \
436         scripts/gnt-os
437
438 PYTHON_BOOTSTRAP = \
439         $(PYTHON_BOOTSTRAP_SBIN) \
440         tools/ensure-dirs
441
442 qa_scripts = \
443         qa/ganeti-qa.py \
444         qa/qa_cluster.py \
445         qa/qa_config.py \
446         qa/qa_daemon.py \
447         qa/qa_env.py \
448         qa/qa_error.py \
449         qa/qa_instance.py \
450         qa/qa_node.py \
451         qa/qa_os.py \
452         qa/qa_rapi.py \
453         qa/qa_tags.py \
454         qa/qa_utils.py
455
456 bin_SCRIPTS =
457 if WANT_HTOOLS
458 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
459 install-exec-hook:
460         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
461 # FIXME: this is a hardcoded logic, instead of auto-resolving
462         $(LN_S) -f ../../../bin/htools \
463                    $(DESTDIR)$(iallocatorsdir)/hail
464         for role in $(HS_BIN_ROLES); do \
465                 $(LN_S) -f htools \
466                            $(DESTDIR)$(bindir)/$$role ; \
467         done
468 endif
469
470 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
471         @if [ -z "$(HTOOLS)" ]; then \
472           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
473           exit 1; \
474         fi
475         @BINARY=$(@:htools/%=%); \
476         if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
477           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
478           exit 1; \
479         fi
480         BINARY=$(@:htools/%=%); $(GHC) --make \
481           $(HFLAGS) $(HEXTRA) \
482           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
483           -osuf $$BINARY.o -hisuf $$BINARY.hi $@
484
485 # for the htools/test binary, we need to enable profiling/coverage
486 htools/test: HEXTRA=-fhpc -Wwarn -fno-warn-missing-signatures \
487         -fno-warn-monomorphism-restriction -fno-warn-orphans \
488         -fno-warn-missing-methods -fno-warn-unused-imports
489
490 dist_sbin_SCRIPTS = \
491         tools/ganeti-listrunner
492
493 nodist_sbin_SCRIPTS = \
494         $(PYTHON_BOOTSTRAP_SBIN) \
495         daemons/ganeti-cleaner
496
497 dist_tools_PYTHON = \
498         tools/burnin \
499         tools/cfgshell \
500         tools/cfgupgrade \
501         tools/cfgupgrade12 \
502         tools/cluster-merge \
503         tools/lvmstrap \
504         tools/move-instance \
505         tools/setup-ssh \
506         tools/sanitize-config
507
508 dist_tools_SCRIPTS = \
509         $(dist_tools_PYTHON) \
510         tools/kvm-console-wrapper \
511         tools/xm-console-wrapper
512
513 pkglib_python_scripts = \
514         daemons/import-export \
515         tools/check-cert-expired
516
517 nodist_pkglib_python_scripts = \
518         tools/ensure-dirs
519
520 pkglib_SCRIPTS = \
521         daemons/daemon-util \
522         tools/kvm-ifup \
523         $(pkglib_python_scripts)
524
525 nodist_pkglib_SCRIPTS = \
526         $(nodist_pkglib_python_scripts)
527
528 EXTRA_DIST = \
529         NEWS \
530         UPGRADE \
531         epydoc.conf.in \
532         pylintrc \
533         autotools/build-bash-completion \
534         autotools/check-python-code \
535         autotools/check-man \
536         autotools/check-news \
537         autotools/check-tar \
538         autotools/check-version \
539         autotools/convert-constants \
540         autotools/docpp \
541         autotools/gen-coverage \
542         autotools/testrunner \
543         $(RUN_IN_TEMPDIR) \
544         daemons/daemon-util.in \
545         daemons/ganeti-cleaner.in \
546         $(pkglib_python_scripts) \
547         devel/upload.in \
548         tools/kvm-ifup.in \
549         $(docdot) \
550         $(docpng) \
551         $(docrst) \
552         doc/conf.py \
553         doc/html \
554         doc/examples/ganeti.initd.in \
555         doc/examples/ganeti-kvm-poweroff.initd.in \
556         doc/examples/ganeti.cron.in \
557         doc/examples/gnt-config-backup.in \
558         doc/examples/ganeti.default \
559         doc/examples/ganeti.default-debug \
560         doc/examples/hooks/ethers \
561         doc/examples/hooks/ipsec.in \
562         doc/examples/gnt-debug/README \
563         doc/examples/gnt-debug/delay0.json \
564         doc/examples/gnt-debug/delay50.json \
565         test/testutils.py \
566         test/mocks.py \
567         $(dist_TESTS) \
568         $(TEST_FILES) \
569         man/footer.rst \
570         $(manrst) \
571         $(maninput) \
572         qa/qa-sample.json \
573         $(qa_scripts) \
574         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
575         $(HS_PROG_SRCS)
576
577 man_MANS = \
578         man/ganeti.7 \
579         man/ganeti-cleaner.8 \
580         man/ganeti-confd.8 \
581         man/ganeti-listrunner.8 \
582         man/ganeti-masterd.8 \
583         man/ganeti-noded.8 \
584         man/ganeti-os-interface.7 \
585         man/ganeti-rapi.8 \
586         man/ganeti-watcher.8 \
587         man/gnt-backup.8 \
588         man/gnt-cluster.8 \
589         man/gnt-debug.8 \
590         man/gnt-group.8 \
591         man/gnt-instance.8 \
592         man/gnt-job.8 \
593         man/gnt-node.8 \
594         man/gnt-os.8 \
595         man/hail.1 \
596         man/hbal.1 \
597         man/hscan.1 \
598         man/hspace.1 \
599         man/htools.1
600
601 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
602 manhtml = $(patsubst %.rst,%.html,$(manrst))
603 mangen = $(patsubst %.rst,%.gen,$(manrst))
604 maninput = \
605         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
606         $(patsubst %.html,%.html.in,$(manhtml)) \
607         man/footer.man man/footer.html $(mangen)
608
609 TEST_FILES = \
610         test/data/bdev-drbd-8.0.txt \
611         test/data/bdev-drbd-8.3.txt \
612         test/data/bdev-drbd-disk.txt \
613         test/data/bdev-drbd-net-ip4.txt \
614         test/data/bdev-drbd-net-ip6.txt \
615         test/data/cert1.pem \
616         test/data/proc_drbd8.txt \
617         test/data/proc_drbd80-emptyline.txt \
618         test/data/proc_drbd83.txt \
619         test/data/sys_drbd_usermode_helper.txt \
620         test/import-export_unittest-helper
621
622 python_tests = \
623         test/ganeti.asyncnotifier_unittest.py \
624         test/ganeti.backend_unittest.py \
625         test/ganeti.bdev_unittest.py \
626         test/ganeti.cli_unittest.py \
627         test/ganeti.client.gnt_cluster_unittest.py \
628         test/ganeti.client.gnt_instance_unittest.py \
629         test/ganeti.daemon_unittest.py \
630         test/ganeti.cmdlib_unittest.py \
631         test/ganeti.compat_unittest.py \
632         test/ganeti.confd.client_unittest.py \
633         test/ganeti.config_unittest.py \
634         test/ganeti.constants_unittest.py \
635         test/ganeti.errors_unittest.py \
636         test/ganeti.hooks_unittest.py \
637         test/ganeti.ht_unittest.py \
638         test/ganeti.http_unittest.py \
639         test/ganeti.hypervisor_unittest.py \
640         test/ganeti.hypervisor.hv_chroot_unittest.py \
641         test/ganeti.hypervisor.hv_fake_unittest.py \
642         test/ganeti.hypervisor.hv_kvm_unittest.py \
643         test/ganeti.hypervisor.hv_lxc_unittest.py \
644         test/ganeti.hypervisor.hv_xen_unittest.py \
645         test/ganeti.impexpd_unittest.py \
646         test/ganeti.jqueue_unittest.py \
647         test/ganeti.locking_unittest.py \
648         test/ganeti.luxi_unittest.py \
649         test/ganeti.masterd.instance_unittest.py \
650         test/ganeti.mcpu_unittest.py \
651         test/ganeti.netutils_unittest.py \
652         test/ganeti.objects_unittest.py \
653         test/ganeti.opcodes_unittest.py \
654         test/ganeti.qlang_unittest.py \
655         test/ganeti.query_unittest.py \
656         test/ganeti.rapi.baserlib_unittest.py \
657         test/ganeti.rapi.client_unittest.py \
658         test/ganeti.rapi.resources_unittest.py \
659         test/ganeti.rapi.rlib2_unittest.py \
660         test/ganeti.rpc_unittest.py \
661         test/ganeti.runtime_unittest.py \
662         test/ganeti.serializer_unittest.py \
663         test/ganeti.ssh_unittest.py \
664         test/ganeti.tools.ensure_dirs_unittest.py \
665         test/ganeti.uidpool_unittest.py \
666         test/ganeti.utils.algo_unittest.py \
667         test/ganeti.utils.filelock_unittest.py \
668         test/ganeti.utils.hash_unittest.py \
669         test/ganeti.utils.io_unittest.py \
670         test/ganeti.utils.log_unittest.py \
671         test/ganeti.utils.mlock_unittest.py \
672         test/ganeti.utils.nodesetup_unittest.py \
673         test/ganeti.utils.process_unittest.py \
674         test/ganeti.utils.retry_unittest.py \
675         test/ganeti.utils.text_unittest.py \
676         test/ganeti.utils.wrapper_unittest.py \
677         test/ganeti.utils.x509_unittest.py \
678         test/ganeti.utils_unittest.py \
679         test/ganeti.workerpool_unittest.py \
680         test/cfgupgrade_unittest.py \
681         test/docs_unittest.py \
682         test/tempfile_fork_unittest.py
683
684 haskell_tests = htools/test
685
686 dist_TESTS = \
687         test/check-cert-expired_unittest.bash \
688         test/daemon-util_unittest.bash \
689         test/ganeti-cleaner_unittest.bash \
690         test/import-export_unittest.bash \
691         $(python_tests)
692
693 nodist_TESTS =
694 if WANT_HTOOLSTESTS
695 nodist_TESTS += $(haskell_tests)
696 endif
697
698 TESTS = $(dist_TESTS) $(nodist_TESTS)
699
700 # Environment for all tests
701 PLAIN_TESTS_ENVIRONMENT = \
702         PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) $(RUN_IN_TEMPDIR)
703
704 # Environment for tests run by automake
705 TESTS_ENVIRONMENT = \
706         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
707
708 all_python_code = \
709         $(dist_sbin_SCRIPTS) \
710         $(dist_tools_PYTHON) \
711         $(pkglib_python_scripts) \
712         $(nodist_pkglib_python_scripts) \
713         $(python_tests) \
714         $(pkgpython_PYTHON) \
715         $(client_PYTHON) \
716         $(hypervisor_PYTHON) \
717         $(rapi_PYTHON) \
718         $(server_PYTHON) \
719         $(pytools_PYTHON) \
720         $(http_PYTHON) \
721         $(confd_PYTHON) \
722         $(masterd_PYTHON) \
723         $(impexpd_PYTHON) \
724         $(utils_PYTHON) \
725         $(watcher_PYTHON) \
726         $(noinst_PYTHON) \
727         $(qa_scripts)
728
729 srclink_files = \
730         man/footer.rst \
731         test/check-cert-expired_unittest.bash \
732         test/daemon-util_unittest.bash \
733         test/ganeti-cleaner_unittest.bash \
734         test/import-export_unittest.bash \
735         $(all_python_code) \
736         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
737
738 check_python_code = \
739         $(BUILD_BASH_COMPLETION) \
740         $(DOCPP) \
741         $(all_python_code)
742
743 lint_python_code = \
744         ganeti \
745         ganeti/http/server.py \
746         $(dist_sbin_SCRIPTS) \
747         $(dist_tools_PYTHON) \
748         $(pkglib_python_scripts) \
749         $(BUILD_BASH_COMPLETION) \
750         $(DOCPP) \
751         $(PYTHON_BOOTSTRAP)
752
753 test/daemon-util_unittest.bash: daemons/daemon-util
754
755 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
756
757 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
758         sed -f $(REPLACE_VARS_SED) < $< > $@
759         chmod +x $@
760
761 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
762         sed -f $(REPLACE_VARS_SED) < $< > $@
763         chmod u+x $@
764
765 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
766         sed -f $(REPLACE_VARS_SED) < $< > $@
767         chmod +x $@
768
769 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
770         sed -f $(REPLACE_VARS_SED) < $< > $@
771
772 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
773         sed -f $(REPLACE_VARS_SED) < $< > $@
774
775 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
776         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
777         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
778
779 doc/%.png: doc/%.dot
780         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
781         $(DOT) -Tpng -o $@ $<
782
783 man/footer.man: man/footer.rst
784         @test -n "$(PANDOC)" || \
785           { echo 'pandoc' not found during configure; exit 1; }
786         $(PANDOC) -f rst -t man -o $@ $<
787
788 man/footer.html: man/footer.rst
789         @test -n "$(PANDOC)" || \
790           { echo 'pandoc' not found during configure; exit 1; }
791         $(PANDOC) -f rst -t html -o $@ $<
792
793 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py
794         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
795
796 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
797         @test -n "$(PANDOC)" || \
798           { echo 'pandoc' not found during configure; exit 1; }
799         set -o pipefail ; \
800         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
801           sed -e 's/\\@/@/g' > $@
802         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
803
804 man/%.html.in: man/%.gen man/footer.html
805         @test -n "$(PANDOC)" || \
806           { echo 'pandoc' not found during configure; exit 1; }
807         set -o pipefail ; \
808         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
809           sed -e 's/\\@/@/g' > $@
810
811 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
812         sed -f $(REPLACE_VARS_SED) < $< > $@
813
814 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
815         sed -f $(REPLACE_VARS_SED) < $< > $@
816
817 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
818         sed -f $(REPLACE_VARS_SED) < $< > $@
819
820 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
821         sed -f $(REPLACE_VARS_SED) < $< > $@
822
823 epydoc.conf: epydoc.conf.in Makefile
824         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
825
826 vcs-version:
827         if test -d .git; then \
828           git describe > $@; \
829         elif test ! -f $@ ; then \
830           echo "Cannot auto-generate $@ file"; exit 1; \
831         fi
832
833 .PHONY: regen-vcs-version
834 regen-vcs-version:
835         set -e; \
836         cd $(srcdir); \
837         if test -d .git; then \
838           rm -f vcs-version; \
839           $(MAKE) vcs-version; \
840         fi
841
842 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
843         set -e; \
844         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
845         sed -e "s/%ver%/$$VCSVER/" < $< > $@
846
847 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
848         lib/constants.py lib/_autoconf.py $(CONVERT_CONSTANTS)
849         set -e; \
850         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
851
852 lib/_autoconf.py: Makefile | lib/.dir
853         set -e; \
854         { echo '# This file is automatically generated, do not edit!'; \
855           echo '#'; \
856           echo ''; \
857           echo '"""Build-time configuration for Ganeti.'; \
858           echo '';\
859           echo 'This file is autogenerated by the build process.'; \
860           echo 'For any changes you need to re-run ./configure (and'; \
861           echo 'not edit by hand).'; \
862           echo ''; \
863           echo '"""'; \
864           echo ''; \
865           echo '# pylint: disable-msg=C0301,C0324'; \
866           echo '# because this is autogenerated, we do not want'; \
867           echo '# style warnings' ; \
868           echo ''; \
869           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
870           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
871           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
872           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
873           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
874           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
875           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
876           echo "SYSCONFDIR = '$(sysconfdir)'"; \
877           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
878           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
879           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
880           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
881           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
882           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
883           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
884           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
885           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
886           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
887           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
888           echo "KVM_PATH = '$(KVM_PATH)'"; \
889           echo "SOCAT_PATH = '$(SOCAT)'"; \
890           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
891           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
892           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
893           echo "TOOLSDIR = '$(toolsdir)'"; \
894           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
895           echo "PKGLIBDIR = '$(pkglibdir)'"; \
896           echo "DRBD_BARRIERS = $(DRBD_BARRIERS)"; \
897           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
898           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
899           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
900           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
901           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
902           echo "RAPI_USER = '$(RAPI_USER)'"; \
903           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
904           echo "CONFD_USER = '$(CONFD_USER)'"; \
905           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
906           echo "NODED_USER = '$(NODED_USER)'"; \
907           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
908           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
909           if [ "$(HTOOLS)" ]; then \
910             echo "HTOOLS = True"; \
911           else \
912             echo "HTOOLS = False"; \
913           fi; \
914         } > $@
915
916 lib/_vcsversion.py: Makefile vcs-version | lib/.dir
917         set -e; \
918         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
919         { echo '# This file is automatically generated, do not edit!'; \
920           echo '#'; \
921           echo ''; \
922           echo '"""Build-time VCS version number for Ganeti.'; \
923           echo '';\
924           echo 'This file is autogenerated by the build process.'; \
925           echo 'For any changes you need to re-run ./configure (and'; \
926           echo 'not edit by hand).'; \
927           echo ''; \
928           echo '"""'; \
929           echo ''; \
930           echo '# pylint: disable-msg=C0301,C0324'; \
931           echo '# because this is autogenerated, we do not want'; \
932           echo '# style warnings' ; \
933           echo ''; \
934           echo "VCS_VERSION = '$$VCSVER'"; \
935         } > $@
936
937 $(REPLACE_VARS_SED): Makefile
938         set -e; \
939         { echo 's#@PREFIX@#$(prefix)#g'; \
940           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
941           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
942           echo 's#@BINDIR@#$(bindir)#g'; \
943           echo 's#@SBINDIR@#$(sbindir)#g'; \
944           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
945           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
946           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
947           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
948           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
949           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
950           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
951           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
952           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
953           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
954           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
955           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
956           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
957           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
958           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
959           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
960           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
961           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
962         } > $@
963
964 # Using deferred evaluation
965 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
966 daemons/ganeti-watcher: MODULE = ganeti.watcher
967 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
968 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
969
970 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
971         test -n "$(MODULE)" || { echo Missing module; exit 1; }
972         set -e; \
973         { echo '#!/usr/bin/python'; \
974           echo '# This file is automatically generated, do not edit!'; \
975           echo "# Edit $(MODULE) instead."; \
976           echo; \
977           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
978           echo; \
979           echo '# pylint: disable-msg=C0103'; \
980           echo '# C0103: Invalid name'; \
981           echo; \
982           echo 'import sys'; \
983           echo 'import $(MODULE) as main'; \
984           echo; \
985           echo '# Temporarily alias commands until bash completion'; \
986           echo '# generator is changed'; \
987           echo 'if hasattr(main, "commands"):'; \
988           echo '  commands = main.commands # pylint: disable-msg=E1101'; \
989           echo 'if hasattr(main, "aliases"):'; \
990           echo '  aliases = main.aliases # pylint: disable-msg=E1101'; \
991           echo; \
992           echo 'if __name__ == "__main__":'; \
993           echo '  sys.exit(main.Main())'; \
994         } > $@
995         chmod u+x $@
996
997 # We need to create symlinks because "make distcheck" will not install Python
998 # files when building.
999 stamp-srclinks: Makefile | $(all_dirfiles)
1000         set -e; \
1001         for i in $(srclink_files); do \
1002                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1003                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1004                 fi; \
1005         done
1006         touch $@
1007
1008 .PHONY: ganeti
1009 ganeti:
1010         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1011
1012 .PHONY: check-dirs
1013 check-dirs: $(BUILT_SOURCES)
1014         @set -e; \
1015         find . -type d \( \( -name . \) -o \( \
1016                 -name .git -o \
1017                 -name autom4te.cache \
1018                 \) -prune -o -print \) | { \
1019                 error=; \
1020                 while read dir; do \
1021                         case "$$dir" in \
1022                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1023                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1024                         esac; \
1025                 done; \
1026                 for dir in $(DIRS); do \
1027                         if ! test -d "$$dir"; then \
1028                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1029                                 error=1; \
1030                         fi \
1031                 done; \
1032                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1033         }
1034
1035 check-local: check-dirs
1036         $(CHECK_PYTHON_CODE) $(check_python_code)
1037         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1038         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1039         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1040         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1041                 echo "Incorrect version in README, expected $$expver"; \
1042                 exit 1; \
1043         fi; \
1044         if test "`sed -ne '4 p' $(top_srcdir)/doc/iallocator.rst`" != \
1045                                         "Documents Ganeti version $$expver"; then \
1046                 echo "Incorrect version in iallocator.rst, expected $$expver"; \
1047                 exit 1; \
1048         fi
1049
1050 .PHONY: hs-check
1051 hs-check: htools/test
1052         @rm -f test.tix
1053         ./htools/test
1054
1055 .PHONY: lint
1056 lint: $(BUILT_SOURCES)
1057         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1058         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1059         cd $(top_srcdir)/qa && \
1060           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1061           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1062
1063 .PHONY: hlint
1064 hlint: $(HS_BUILT_SRCS)
1065         if tty -s; then C="-c"; else C=""; fi; \
1066         hlint --report=doc/hs-lint.html $$C htools
1067
1068 # a dist hook rule for updating the vcs-version file; this is
1069 # hardcoded due to where it needs to build the file...
1070 dist-hook:
1071         $(MAKE) regen-vcs-version && \
1072         rm -f $(top_distdir)/vcs-version && \
1073         cp -p $(srcdir)/vcs-version $(top_distdir)
1074
1075 # a distcheck hook rule for catching revision control directories
1076 distcheck-hook:
1077         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1078                 echo "Found revision control files in final archive." 1>&2; \
1079                 exit 1; \
1080         fi
1081         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1082                 echo "Found Python byte code in final archive." 1>&2; \
1083                 exit 1; \
1084         fi
1085         if find $(top_distdir) -name '*~' | grep .; then \
1086                 echo "Found backup files in final archive." 1>&2; \
1087                 exit 1; \
1088         fi
1089 # Empty files or directories should not be distributed. They can cause
1090 # unnecessary warnings for packagers. Directories used by automake during
1091 # distcheck must be excluded.
1092         if find $(top_distdir) -empty -and -not \( \
1093                         -path $(top_distdir)/_build -or \
1094                         -path $(top_distdir)/_inst \) | grep .; then \
1095                 echo "Found empty files or directories in final archive." 1>&2; \
1096                 exit 1; \
1097         fi
1098         if test -n "$(BUILD_RELEASE)" && \
1099            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1100                 echo "Found unreleased version in NEWS." >&2; \
1101                 exit 1; \
1102         fi
1103
1104 # When building a release, stricter checks should be used
1105 distcheck-release dist-release: export BUILD_RELEASE = 1
1106 distcheck-release: distcheck
1107
1108 dist-release: dist
1109         set -e; \
1110         for i in $(DIST_ARCHIVES); do \
1111                 echo -n "Checking $$i ... "; \
1112                 autotools/check-tar < $$i; \
1113                 echo OK; \
1114         done
1115
1116 install-exec-local:
1117         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1118           "$(DESTDIR)${localstatedir}/log/ganeti" \
1119           "$(DESTDIR)${localstatedir}/run/ganeti"
1120
1121 # To avoid conflicts between directory names and other targets, a file inside
1122 # the directory is used to ensure its existence.
1123 %.dir:
1124         @mkdir_p@ $* && touch $@
1125
1126 .PHONY: apidoc
1127 if WANT_HTOOLSAPIDOC
1128 apidoc: py-apidoc hs-apidoc
1129 else
1130 apidoc: py-apidoc
1131 endif
1132
1133 .PHONY: py-apidoc
1134 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1135         $(RUN_IN_TEMPDIR) epydoc -v \
1136                 --conf $(CURDIR)/epydoc.conf \
1137                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1138
1139 .PHONY: hs-apidoc
1140 hs-apidoc: $(HS_BUILT_SRCS)
1141         @test -n "$(HSCOLOUR)" || \
1142             { echo 'HsColour' not found during configure; exit 1; }
1143         @test -n "$(HADDOCK)" || \
1144             { echo 'haddock' not found during configure; exit 1; }
1145         rm -rf $(APIDOC_HS_DIR)/*
1146         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1147         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1148         ln -s ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1149         set -e ; \
1150         cd htools; \
1151         if [ "$(HTOOLS_NOCURL)" ]; \
1152         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1153         else OPTGHC=""; \
1154         fi; \
1155         if [ "$(HTOOLS_PARALLEL3)" ]; \
1156         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1157         fi; \
1158         RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1159         for file in $$RELSRCS; do \
1160                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1161                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1162         done ; \
1163         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1164                 -t ganeti-htools -p haddock-prologue \
1165                 --source-module="%{MODULE/.//}.html" \
1166                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1167                 $$OPTGHC \
1168                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1169
1170 .PHONY: TAGS
1171 TAGS: $(BUILT_SOURCES)
1172         rm -f TAGS
1173         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1174           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1175           -path './qa/*.py' | \
1176           etags -l python -
1177
1178 .PHONY: coverage
1179 if WANT_HTOOLS
1180 coverage: py-coverage hs-coverage
1181 else
1182 coverage: py-coverage
1183 endif
1184
1185 .PHONY: py-coverage
1186 py-coverage: $(BUILT_SOURCES) $(python_tests)
1187         set -e; \
1188         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1189         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1190         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1191         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1192         $(python_tests)
1193
1194 .PHONY: hs-coverage
1195 hs-coverage: $(haskell_tests)
1196         cd htools && rm -f *.tix *.mix && ./test
1197         @mkdir_p@ $(COVERAGE_HS_DIR)
1198         hpc markup --destdir=$(COVERAGE_HS_DIR) htools/test $(HPCEXCL)
1199         hpc report htools/test $(HPCEXCL)
1200         ln -sf hpc_index.html $(COVERAGE_HS_DIR)/index.html
1201
1202 # Special "kind-of-QA" target for htools, needs special setup (all
1203 # tools compiled with -fhpc)
1204 .PHONY: live-test
1205 live-test: all
1206         set -e ; \
1207         cd htools; \
1208         rm -f .hpc; ln -s ../.hpc .hpc; \
1209         rm -f *.tix *.mix; \
1210         ./live-test.sh; \
1211         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1212           --output=live-test.tix ; \
1213         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1214         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1215                 --srcdir=.. $(HPCEXCL) ; \
1216         hpc report --srcdir=.. live-test $(HPCEXCL)
1217
1218 commit-check: distcheck lint apidoc
1219
1220 -include ./Makefile.local
1221
1222 # vim: set noet :